# -*- coding: utf-8 -*-
"""
Created on Fri Apr  5 16:52:48 2024

@author: yj
"""

import onnx
# Import the ktc package which is our Python API.
import ktc
import cv2
import tensorflow as tf
import random
import numpy as np
import videoto3d

kneron_boardType = "630"

onnx_file_path = "./model_3DCNN_LR4_1652_ops11.onnx"

# Opset_version Check
model = onnx.load(onnx_file_path)
opset_version = model.opset_import[0].version if len(model.opset_import) > 0 else None
print(opset_version)

# 1. Load the model.
#original_m = onnx.load("./model_3DCNN_LeaklyRelu4_128.onnx")
original_m = onnx.load(onnx_file_path)

# 2. Optimize the model using optimizer for onnx model.
optimized_m = ktc.onnx_optimizer.onnx2onnx_flow(original_m)
onnx.save(optimized_m, "./optimized_3dcnn.onnx")

# Save the onnx object optimized_m to path optimized.onnx.
'''
class ktc.ModelConfig(self, id, version, platform, onnx_model=None, onnx_path=None, bie_path=None)
Create an Kneron model config object. One of these three parameters is required: onnx_model, onnx_path, bie_path.

Args:

id (int): model ID
version (str): version number which should be a four digit hex, e.g. "0a2f"
platform (str): hardware platform, should be one of "520", "720", "530", "630", "730"
onnx_model (ModelProto, optional): loaded onnx model object. Defaults to None.
onnx_path (str, optional): onnx file path. Defaults to None.
bie_path (str, optional): bie file path. Defaults to None.
radix_json_path (str, optional): radix json path. Defaults to None.
compiler_config_path (str, optional): compiler config json path. Defaults to None.
debug (bool, optional): keep the debug output files. Defaults to False.
'''
#km = ktc.ModelConfig(1, "0001", "630", onnx_path="optimized_3dcnn.onnx")
# Model IDs must be larger than 32767
km = ktc.ModelConfig(35000, "0001", "630", onnx_path="optimized_3dcnn.onnx")
# Evaluate the model. The evaluation result is saved as string into `eval_result`.
eval_result = km.evaluate()


'''
#-- Check input
# We need to prepare a dictionary, which mapping the input name to a list of preprocessed arrays.
input_np = np.zeros([32,32,15,3])
input_np = np.expand_dims(input_np, 0)
input_mapping = {"video": input_np}

bie_path = km.analysis(input_mapping, threads = 4)
fixed_results = ktc.kneron_inference(input_data, bie_file=bie_path, input_names=["video"], platform=630)
'''

#img_rows, img_cols, frames = 32, 32, 15
#img_rows, img_cols, frames = 64, 64, 
img_rows, img_cols, frames = 128, 128, 15
#img_rows, img_cols, frames = 320, 320, 15

vid3d = videoto3d.Videoto3D(img_rows, img_cols, frames)
video_path = "./video/1.avi"
video_np = vid3d.video3d(video_path, color=True, skip=False)

video_np = np.swapaxes(video_np, 0, 1)
video_np = np.swapaxes(video_np, 1, 2)

video_np = np.expand_dims(video_np, 0)
print(video_np.shape)
#print(type(video_np))
#print(video_np.shape)

video_np_list = [video_np]
input_data = video_np_list

input_mapping = {"serving_default_conv3d_input:0": video_np_list}
bie_path = km.analysis(input_mapping, threads = 4)
fixed_results = ktc.kneron_inference(input_data, bie_file=bie_path, input_names=["serving_default_conv3d_input:0"], platform= 630)


# bin 
nef_path = ktc.compile([km])

#nef 모델이	정상작동하는지	확인
hw_results = ktc.kneron_inference(input_data,  nef_file=nef_path, input_names=["serving_default_conv3d_input:0"], platform= 630)

# Compare binary_inf_results and fixed_point_inf_results. They should be almost the same.
print("Fixed \n")
print(fixed_results)
print("HW \n")
print(hw_results)


